library test.encode;

import 'package:test/test.dart';
import 'package:jaguar_jwt/jaguar_jwt.dart';

final key = 'secret';

main() {
  group('Encoding', () {
    test('Nopayload', () {
      final claimSet = new JwtClaim(
          issuer: 'teja',
          subject: '1234567890',
          audience: ["admin", "students"],
          issuedAt: new DateTime.fromMillisecondsSinceEpoch(1481842800000,
              isUtc: true));
      String token = issueJwtHS256(claimSet, key);
      expect(token,
          r'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOlsiYWRtaW4iLCJzdHVkZW50cyJdLCJleHAiOjg2NDAwLCJpYXQiOiIyMDE2LTEyLTE1VDIzOjAwOjAwLjAwMFoiLCJpc3MiOiJ0ZWphIiwic3ViIjoiMTIzNDU2Nzg5MCJ9.Vni4th0LB6skPofO8r0T9R-qvptF-qEgRMbWvJdOzJ8=');
    });

    test('With payload', () {
      final claimSet = new JwtClaim(
          issuer: 'teja',
          subject: '1234567890',
          audience: ["admin", "students"],
          issuedAt: new DateTime.fromMillisecondsSinceEpoch(1481842800000,
              isUtc: true),
          payload: {"k": "v"});
      String token = issueJwtHS256(claimSet, key);
      expect(token,
          r'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJhdWQiOlsiYWRtaW4iLCJzdHVkZW50cyJdLCJleHAiOjg2NDAwLCJpYXQiOiIyMDE2LTEyLTE1VDIzOjAwOjAwLjAwMFoiLCJpc3MiOiJ0ZWphIiwicGxkIjp7ImsiOiJ2In0sInN1YiI6IjEyMzQ1Njc4OTAifQ==.j0BpvzJdpy6mR6-b21eiPAnDCg84goe_oUsMrm9WRWU=');
    });
  });
}
